package IC2BackpackHUD;

import java.util.EnumSet;

import org.lwjgl.opengl.GL11;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import cpw.mods.fml.common.ITickHandler;
import cpw.mods.fml.common.TickType;
import ic2.api.Items;
import ic2.api.IElectricItem;

public class ClientTickHandler implements ITickHandler
{

	private Minecraft minecraft = Minecraft.getMinecraft();
	long timeElapsed = System.nanoTime(); // Used to flash low armor-item charge
	boolean overlayGUI = true; // On low-charge, tells whether GUI is visible based on elapsed time above

    @Override
    public void tickStart(EnumSet<TickType> type, Object... tickData) {}

    @Override
    public void tickEnd(EnumSet<TickType> type, Object... tickData)
    {
        if (type.equals(EnumSet.of(TickType.RENDER)))
        {
            onRenderTick();
        }
        else if (type.equals(EnumSet.of(TickType.CLIENT)))
        {
            GuiScreen guiscreen = Minecraft.getMinecraft().currentScreen;
            if (guiscreen != null)
            {
                onTickInGUI(guiscreen);
            } else {
                onTickInGame();
            }
        }
    }

    @Override
    public EnumSet<TickType> ticks()
    {
        return EnumSet.of(TickType.RENDER, TickType.CLIENT);
    }

    @Override
    public String getLabel() { return null; }

	public void onRenderTick()
	{
		if (minecraft.currentScreen == null)
		{
			ScaledResolution var5 = new ScaledResolution(minecraft.gameSettings, minecraft.displayWidth, minecraft.displayHeight);
			boolean var6 = false;
			int var7 = var5.getScaledWidth();
			int var8 = var5.getScaledHeight();
			byte var9 = 8;
			boolean var10 = true;
			short var11 = (short)(18 * var9);
			ItemStack var12;
			Item var13;
			int var14;
			String var15;
			int maxItemDamage;
			int itemDamage;
			boolean var19;
			int quantizedHealthTo15;
			int var21;
			int var20;
			int var22;
			boolean validItem = false;
			if (minecraft.thePlayer.inventory.armorInventory[2] != null) {
				if (minecraft.thePlayer.inventory.armorInventory[2].getItem() instanceof IElectricItem && IC2BackpackHUD.showOtherElectricItems) validItem = true;
				else if (
						minecraft.thePlayer.inventory.armorInventory[2].itemID == Items.getItem("jetpack").itemID ||
						minecraft.thePlayer.inventory.armorInventory[2].itemID == Items.getItem("electricJetpack").itemID ||
						minecraft.thePlayer.inventory.armorInventory[2].itemID == Items.getItem("batPack").itemID ||
						minecraft.thePlayer.inventory.armorInventory[2].itemID == Items.getItem("lapPack").itemID ||
						minecraft.thePlayer.inventory.armorInventory[2].itemID == Items.getItem("cfPack").itemID		
						)
				{
					validItem = true;
				}
			if (validItem)
			{
					var12 = minecraft.thePlayer.inventory.armorInventory[2];
					var13 = var12.getItem();
					var14 = var12.getIconIndex();
					var15 = var13.getTextureFile();
					itemDamage = var12.getItemDamage();
					maxItemDamage = var13.getMaxDamage();
					quantizedHealthTo15 = this.mapDamagetoHealthto15(itemDamage, maxItemDamage);
					var19 = false;
					var20 = 0;

					for (var21 = var14; var21 > 15; ++var20)
						var21 -= 16;

					var22 = var21 * 16;
					var20 *= 16;

					// Check against elapsed time to determine whether overlayGUI is true or false for low charge
					if ((System.nanoTime() - timeElapsed) > 250000000 && (quantizedHealthTo15 <= 2) && (quantizedHealthTo15 != 0)) 
					{
						timeElapsed = System.nanoTime(); // Reset time lapsed
						overlayGUI = !overlayGUI; // Toggle overlay GUI on or off
					};

		            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
					
					// Draw armor item
					GL11.glBindTexture(GL11.GL_TEXTURE_2D, minecraft.renderEngine.getTexture(var15)); // Get texture for armor chest item
					this.drawTexturedModalRect(var7 / 2 - 111, var8 - 15 - 4, var22, var20, 16, 16); // Draw texture for armor chest item
					if ((quantizedHealthTo15 <= 2) && (overlayGUI)) {
						GL11.glBindTexture(GL11.GL_TEXTURE_2D, minecraft.renderEngine.getTexture("/IC2BackpackHUD/gui/items.png")); // Get texture for low power flasher
						this.drawTexturedModalRect(var7 / 2 - 111, var8 - 15 - 4, 0, 16, 16, 16); // Draw texture for low power flasher
					}
					else if (quantizedHealthTo15 == 0) {
						GL11.glBindTexture(GL11.GL_TEXTURE_2D, minecraft.renderEngine.getTexture("/IC2BackpackHUD/gui/items.png")); // Get texture for low power flasher
						this.drawTexturedModalRect(var7 / 2 - 111, var8 - 15 - 4, 0, 16, 16, 16); // Draw texture for low power flasher
					}

					// Draw armor health background bar
					GL11.glBindTexture(GL11.GL_TEXTURE_2D, minecraft.renderEngine.getTexture("/IC2BackpackHUD/gui/items.png")); // Get texture for armor chest health
					this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 0, 14, 2); // Draw texture for armor chest health background

					// Draw quantized health bar overlay
					switch (quantizedHealthTo15) {
					case 14: {
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 2, quantizedHealthTo15, 1);
						break;
					}
					case 13: {
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 3, quantizedHealthTo15, 1);
						break;
					}
					case 12: {
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 4, quantizedHealthTo15, 1);
						break;
					}
					case 11: {
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 5, quantizedHealthTo15, 1);
						break;
					}
					case 10: {
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 6, quantizedHealthTo15, 1);
						break;
					}
					case 9:	{
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 7, quantizedHealthTo15, 1);
						break;
					}
					case 8:	{
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 8, quantizedHealthTo15, 1);
						break;
					}
					case 7:	{
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 9, quantizedHealthTo15, 1);
						break;
					}
					case 6:	{
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 10, quantizedHealthTo15, 1);
						break;
					}
					case 5:	{
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 11, quantizedHealthTo15, 1);
						break;
					}
					case 4:	{
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 12, quantizedHealthTo15, 1);
						break;
					}
					case 3:	{
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 13, quantizedHealthTo15, 1);
						break;
					}
					case 2:	{
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 14, quantizedHealthTo15, 1);
						break;
					}
					case 1:	{
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 15, quantizedHealthTo15, 1);
						break;
					}
					case 0:	{
						this.drawTexturedModalRect(var7 / 2 - 110, var8 - 4, 0, 0, quantizedHealthTo15, 1);
						break;
					}
					}
				}
			}        
		}
	}

	public void drawTexturedModalRect(int var1, int var2, int var3, int var4, int var5, int var6)
	{
		float var7 = 0.00390625F;
		float var8 = 0.00390625F;
		Tessellator var9 = Tessellator.instance;
		var9.startDrawingQuads();
		var9.addVertexWithUV((double)(var1 + 0), (double)(var2 + var6), 0, (double)((float)(var3 + 0) * var7), (double)((float)(var4 + var6) * var8));
		var9.addVertexWithUV((double)(var1 + var5), (double)(var2 + var6), 0, (double)((float)(var3 + var5) * var7), (double)((float)(var4 + var6) * var8));
		var9.addVertexWithUV((double)(var1 + var5), (double)(var2 + 0), 0, (double)((float)(var3 + var5) * var7), (double)((float)(var4 + 0) * var8));
		var9.addVertexWithUV((double)(var1 + 0), (double)(var2 + 0), 0, (double)((float)(var3 + 0) * var7), (double)((float)(var4 + 0) * var8));
		var9.draw();
	}

	public int mapDamagetoHealthto15(int itemDamage, int maxItemDamage)
	{
		int itemHealth = maxItemDamage - itemDamage;
		return itemHealth > maxItemDamage ? 15 : (itemHealth <= 0 ? 0 : (int)((float)itemHealth / (float)maxItemDamage * 15.0F));
	}


    public void onTickInGUI(GuiScreen guiscreen)
    {
        //System.out.println("onTickInGUI");
        //TODO: Your Code Here
    }

    public void onTickInGame()
    {
        //System.out.println("onTickInGame");
        //TODO: Your Code Here
    }
	
}